#    Copyright 2014-2015 ARM Limited
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


from wlauto import LinuxDevice, Parameter


class OdroidXU3LinuxDevice(LinuxDevice):

    name = "odroidxu3_linux"
    description = 'HardKernel Odroid XU3 development board (Ubuntu image).'

    core_modules = [
        'odroidxu3-fan',
    ]

    parameters = [
        Parameter('core_names', default=['a7', 'a7', 'a7', 'a7', 'a15', 'a15', 'a15', 'a15'], override=True),
        Parameter('core_clusters', default=[0, 0, 0, 0, 1, 1, 1, 1], override=True),
    ]

    abi = 'armeabi'
